Imports System.Text
Imports System.Runtime.InteropServices

Public Class WSQImageLibraryNativeMethods

    Dim outODataStream As IntPtr = IntPtr.Zero, outCommentText As IntPtr = IntPtr.Zero
    Dim outCompressBuffer As IntPtr = IntPtr.Zero
    Dim bitmap_ptr As IntPtr = IntPtr.Zero


    Private utf_encoding As New UnicodeEncoding


    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function GenerateWSQLibrarySerialNumber() As IntPtr
    End Function
    Public Function pGenerateWSQLibrarySerialNumber() As IntPtr
        Dim ret As IntPtr

        Try
            ret = GenerateWSQLibrarySerialNumber()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "GenerateWSQLibrarySerialNumber Exception")
        End Try
        pGenerateWSQLibrarySerialNumber = ret
    End Function

    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function UnlockWSQLibrary(ByVal lpszauthorizationcode As Byte()) As IntPtr
    End Function
    Public Function pUnlockWSQLibrary(ByVal authorizationcode As String) As Int32
        Dim ret As Int32

        Try
            ret = UnlockWSQLibrary(utf_encoding.GetBytes(authorizationcode))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "UnlockWSQLibrary Exception")
        End Try
        pUnlockWSQLibrary = ret
    End Function


    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function CreateBMPFromFile(ByVal lpszFileName As Byte()) As IntPtr
    End Function
    Public Function pCreateBMPFromFile(ByVal FileName As String) As IntPtr

        If (FileName = Nothing) Then
            Throw (New ArgumentNullException("FileName should be not null"))
        ElseIf (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try
            bitmap_ptr = CreateBMPFromFile(utf_encoding.GetBytes(FileName))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "CreateBMPFromFile Exception")
        End Try
        pCreateBMPFromFile = bitmap_ptr
    End Function


    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function SaveBMPToFile(ByVal hBitmap As IntPtr, _
            ByVal filename As Byte(), <MarshalAs(UnmanagedType.I4)> ByVal filetype As Int32) As Int32
    End Function
    Public Function pSaveBMPToFile(ByVal Bitmap As IntPtr, ByVal FileName As String, ByVal FileType As Int32) As Int32
        Dim retVal As Int32 = -1
        If (IsNothing(Bitmap) Or (FileName = Nothing)) Then
            Throw New ArgumentNullException("Bitmap and FileName should be not null")
        End If
        If (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try
            retVal = SaveBMPToFile(Bitmap, utf_encoding.GetBytes(FileName), FileType)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SaveBMPToFile Exception")
        End Try
        pSaveBMPToFile = retVal
    End Function



    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function CreateBMPFromWSQByteArray( _
        <[In]()> ByVal input_data_stream As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal input_stream_length As Int32) As IntPtr
    End Function

    Public Function pCreateBMPFromWSQByteArray(<[In]()> ByVal input_data_stream As Byte(), _
              <[In]()> ByVal input_stream_length As Int32) As IntPtr
        Try
            bitmap_ptr = CreateBMPFromWSQByteArray(input_data_stream, input_stream_length)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "CreateBMPFromWSQByteArray Exception")
        End Try

        pCreateBMPFromWSQByteArray = bitmap_ptr

    End Function


    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function SaveWSQByteArrayToImageFile( _
        <[In]()> ByVal input_data_stream As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal input_stream_length As Int32, _
        ByVal lpszFileName As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal filetype As Int32) As Int32
    End Function
    Public Function pSaveWSQByteArrayToImageFile(<[In]()> ByVal input_data_stream As Byte(), _
              <[In]()> ByVal input_stream_length As Int32, ByVal FileName As String, ByVal FileType As Int32) As Int32

        Dim retVal As Int32 = -1

        Try
            retVal = SaveWSQByteArrayToImageFile(input_data_stream, input_stream_length, _
                    utf_encoding.GetBytes(FileName), FileType)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SaveWSQByteArrayToImageFile Exception")
        End Try

        pSaveWSQByteArrayToImageFile = retVal

    End Function


    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Sub SetShowFilePropertiesDialog( _
            <MarshalAs(UnmanagedType.I4)> ByVal file_properties_dialog As Int32)
    End Sub
    Public Sub pSetShowFilePropertiesDialog(ByVal file_properties_dialog As Int32)
        Try
            SetShowFilePropertiesDialog(file_properties_dialog)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SetShowFilePropertiesDialog Exception")
        End Try
    End Sub





    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Sub ShowFileConverter()
    End Sub
    Public Sub pShowFileConverter()
        Try
            ShowFileConverter()
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "ShowFileConverter Exception")
        End Try
    End Sub





    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function WSQ_decode_stream( _
        <[In]()> ByVal input_data_stream As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal input_stream_length As Int32, _
        ByRef output_data_stream As IntPtr, _
        <MarshalAs(UnmanagedType.I4)> ByRef width As Int32, _
        <MarshalAs(UnmanagedType.I4)> ByRef height As Int32, _
        <MarshalAs(UnmanagedType.I4)> ByRef ppi As Int32, _
        ByRef comment_text As IntPtr) As Int32
    End Function
    Public Function pWSQ_decode_stream(<[In]()> ByVal input_data_stream As Byte(), _
                <[In]()> ByVal input_stream_length As Int32, _
                ByRef output_data_stream As Byte(), _
                ByRef width As Int32, _
                ByRef height As Int32, _
                ByRef ppi As Int32, _
                ByRef comment_text As String) As Int32

        Dim retVal As Int32 = -1
        'output_data_stream = new byte[1];
        width = height = ppi = 0
        comment_text = String.Empty


        Try
            WSQ_decode_stream(input_data_stream, input_stream_length, _
                    outODataStream, width, height, _
                    ppi, outCommentText)
            'comment_text = Marshal.PtrToStringAnsi(outCommentText)
            comment_text = Marshal.PtrToStringBSTR(outCommentText) '.NET Compact Framework
            Dim length As Int32 = width * height
            ReDim output_data_stream(length)
            Marshal.Copy(outODataStream, output_data_stream, 0, length)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "WSQ_decode_stream Exception")
        End Try

        pWSQ_decode_stream = retVal

    End Function



    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function WSQ_encode_stream( _
        <[In]()> ByVal inputBuffer As Byte(), _
        <MarshalAs(UnmanagedType.I4)> ByVal width As Int32, _
        <MarshalAs(UnmanagedType.I4)> ByVal height As Int32, _
        <MarshalAs(UnmanagedType.R8)> ByVal bitrate As Double, _
        <MarshalAs(UnmanagedType.I4)> ByVal ppi As Int32, _
        <[In]()> ByVal comment_text As Byte(), _
        ByRef compressBuffer As IntPtr, _
        <MarshalAs(UnmanagedType.I4)> ByRef outputStreamLength As Int32) As Int32
    End Function
    Public Function pWSQ_encode_stream( _
        ByVal inputBuffer As Byte(), _
        ByVal width As Int32, _
        ByVal height As Int32, _
        ByVal bitrate As Double, _
        ByVal ppi As Int32, _
        ByVal commentText As String, _
        ByRef compressBuffer As Byte(), _
        ByRef outputStreamLength As Int32) As Int32

        Dim retVal As Int32 = -1


        compressBuffer = Nothing
        outputStreamLength = 0

        Try
            WSQ_encode_stream(inputBuffer, width, height, _
                    bitrate, ppi, utf_encoding.GetBytes(commentText), _
                    outCompressBuffer, outputStreamLength)
            If (outputStreamLength = 0) Then
                Throw New ArgumentException("outputStreamLength == 0")
            End If
            ReDim compressBuffer(outputStreamLength)
            Marshal.Copy(outCompressBuffer, compressBuffer, 0, outputStreamLength)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "WSQ_encode_stream Exception")
        End Try

        pWSQ_encode_stream = retVal

    End Function


    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function ConvertHBITMAPtoGrayScale256(ByVal hBitmap As IntPtr) As IntPtr
    End Function
    Public Function pConvertHBITMAPtoGrayScale256(ByVal Bitmap As IntPtr) As IntPtr
        Try
            bitmap_ptr = ConvertHBITMAPtoGrayScale256(Bitmap)
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "ConvertHBITMAPtoGrayScale256 Exception")
        End Try
        pConvertHBITMAPtoGrayScale256 = bitmap_ptr
    End Function


    <DllImport("WSQ_libraryCE.dll", CharSet:=CharSet.Unicode)> Private Shared Function SaveHBITMAPtoFileAsGrayScale256BMP(ByVal hBitmap As IntPtr, _
            ByVal filename As Byte()) As Int32
    End Function
    Public Function pSaveHBITMAPtoFileAsGrayScale256BMP(ByVal Bitmap As IntPtr, ByVal FileName As String) As Int32
        Dim retVal As Int32 = -1
        If (IsNothing(Bitmap) Or (FileName = Nothing)) Then
            Throw New ArgumentNullException("Bitmap and FileName should be not null")
        End If
        If (FileName.Length = 0) Then
            Throw New ArgumentException("Incorrect file name")
        End If
        Try
            retVal = SaveHBITMAPtoFileAsGrayScale256BMP(Bitmap, utf_encoding.GetBytes(FileName))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly, "SaveHBITMAPtoFileAsGrayScale256BMP Exception")
        End Try
        pSaveHBITMAPtoFileAsGrayScale256BMP = retVal
    End Function



End Class
